@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!/usr/bin/perl
#line 15

# ToDo 	set up $SBBS_CTRL_PATH properly.
# $SBBS_CTRL_PATH = $ENV{'SBBSCTRL'};
if (defined $ARGV[0])  {
        $SBBS_CTRL_PATH = $ARGV[0];
        $SBBS_CTRL_PATH =~ s/\\/\//g;
        $SBBS_CTRL_PATH =~ s/\/$//g;
}
else  {
        $SBBS_CTRL_PATH = $ENV{'SBBSCTRL'};
        $SBBS_CTRL_PATH =~ s/\\/\//g;
        $SBBS_CTRL_PATH =~ s/\/$//g;
}

if (! -e "$SBBS_CTRL_PATH/main.cnf")  {
        if ($^O =~ /Win32/)  {
                $SBBS_CTRL_PATH = 'C:/SBBS/CTRL';
        }
        else  {
                $SBBS_CTRL_PATH = '/sbbs/ctrl';
        }
}

if (! -e "$SBBS_CTRL_PATH/main.cnf")  {
        print "\n                  Synchronet .CNF to .TXT converter v0.2\n";
        print "                  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\n\n";

        print "This perl script will convert all your .cnf files to plain-text files suitable\n";
        print "for importing with txt2cnf.pl.\n\n";

        print "To use, run it with your ctrl path as the only option as follows:\n";
        print "cnf2txt /sbbs/ctrl\n\n";

}

&read_main;
open MAINOUT,">$SBBS_CTRL_PATH/main.txt";
&write_hash_txt(\*MAINOUT,'',%main);
close MAINOUT;

foreach $node_dir (@{$main{'node_dir'}})  {
        $node_dir =~ s/\\/\//g;
        $node_dir =~ s/\/$//g;
        if ($^O =~ /Win32/)  {
                if ($node_dir !~ /:/)  {
                        $node_dir = "$SBBS_CTRL_PATH/$node_dir/";
                        $node_dir =~ s/\/[^\/]*\/..\//\//g;
                        $node_dir =~ s/\/.\//\//g;
                        $node_dir =~ s/\/$//g;
                }
        }
        else  {
                $node_dir = '$SBBS_CTRL_PATH/$node_dir/';
                $node_dir =~ s/\/[^\/]*\/..\//\//g;
                $node_dir =~ s/\/.\//\//g;
                $node_dir =~ s/\/$//g;
        }
        read_node($node_dir);
        open NODEOUT,">$node_dir/node.txt";
        &write_hash_txt(\*NODEOUT,'',%node);
        close NODEOUT;
}

&read_msgs;
open MSGSOUT,">$SBBS_CTRL_PATH/msgs.txt";
&write_hash_txt(\*MSGSOUT,'',%msgs);
close MSGSOUT;

&read_file;
open FILEOUT,">$SBBS_CTRL_PATH/file.txt";
&write_hash_txt(\*FILEOUT,'',%file);
close FILEOUT;

&read_xtrn;
open XTRNOUT,">$SBBS_CTRL_PATH/xtrn.txt";
&write_hash_txt(\*XTRNOUT,'',%xtrn);
close XTRNOUT;

&read_chat;
open CHATOUT,">$SBBS_CTRL_PATH/chat.txt";
&write_hash_txt(\*CHATOUT,'',%chat);
close CHATOUT;

sub read_main  {

	open MAIN,"$SBBS_CTRL_PATH/main.cnf";
        binmode(MAIN);

	read(MAIN,$input_buffer,229);
        @buffer = unpack('Z41Z9Z41Z13Z41Z41Z41v',$input_buffer);

        ($main{'sys_name'},$main{'sys_id'},$main{'sys_location'},$main{'sys_phonefmt'},
                $main{'sys_op'},$main{'sys_guru'},$main{'sys_pass'},
                $main{'sys_nodes'}) = @buffer;

        foreach (1..$main{'sys_nodes'})  {
		read(MAIN,$input_buffer,64);
		@buffer = unpack('Z64',$input_buffer);
                push @{$main{'node_dir'}},@buffer;
	}

	read(MAIN,$input_buffer,473);
        @buffer=unpack('Z64Z64Z64Z64Z64vVvvVvvCvCZ41vVVZ41Z21Z9Z9',$input_buffer);
        ($main{'data_dir'},$main{'exec_dir'},$main{'sys_logon'},$main{'sys_logoff'},
                $main{'sys_daily'},$main{'sys_timezone'},$main{'sys_misc'},
                $main{'sys_lastnode'},$main{'sys_autonode'},$main{'uq'},
                $main{'sys_pwdays'},$main{'sys_deldays'},$main{'sys_exp_warn'},
                $main{'sys_autodel'},$main{'sys_def_stat'},$main{'sys_chat_ar'},
                $main{'cdt_min_value'},$main{'max_minutes'},$main{'cdt_per_dollar'},
                $main{'new_pass'},$main{'new_magic'},$main{'new_sif'},
                $main{'new_sof'}) = @buffer;

	read(MAIN,$input_buffer,66);
        @buffer=unpack('CV8Z9vvVZ16',$input_buffer);
        ($main{'new_level'},$main{'new_flags1'},$main{'new_flags2'},
                $main{'new_flags3'},$main{'new_flags4'},$main{'new_exempt'},
                $main{'new_rest'},$main{'new_cdt'},$main{'new_min'},
                $main{'new_xedit'},$main{'new_expire'},$main{'new_shell'},
                $main{'new_misc'}) = @buffer;

	read(MAIN,$input_buffer,25);
        @buffer=unpack('CV6',$input_buffer);
        ($main{'expired_level'},$main{'expired_flags1'},$main{'expired_flags2'},
                $main{'expired_flags3'},$main{'expired_flags4'},
                $main{'expired_exempt'},
                $main{'expired_rest'}) = @buffer;

        read(MAIN,$input_buffer,1024);
	@buffer=unpack('Z9Z9Z9Z485Z512',$input_buffer);
        ($main{'logon_mod'},$main{'logoff_mod'},
                $main{'newuser_mod'}) = @buffer;

	foreach (1..10)  {
                my %this_main = ();
		read(MAIN,$input_buffer,47);
                @buffer=unpack('CvVVVVVVVZ16',$input_buffer);
		
                ($this_main{'val_level'},
                        $this_main{'val_expire'},
                        $this_main{'val_flags1'},
                        $this_main{'val_flags2'},
                        $this_main{'val_flags3'},
                        $this_main{'val_flags4'},
                        $this_main{'val_cdt'},
                        $this_main{'val_exempt'},
                        $this_main{'val_rest'}) = @buffer;
                push @{$main{'validation_set'}},\%this_main;
	}

	foreach (1..100)  {
                my %this_main=();
		read(MAIN,$input_buffer,32);
                @buffer=unpack('vvvVvvvZ16',$input_buffer);
                ($this_main{'level_timeperday'},
                        $this_main{'level_timepercall'},
                        $this_main{'level_callsperday'},
                        $this_main{'level_freecdtperday'},
                        $this_main{'level_linespermsg'},
                        $this_main{'level_postsperday'},
                        $this_main{'level_emailperday'}) = @buffer;
                push @{$main{'security_level'}},\%this_main;
	}

	read(MAIN,$input_buffer,2);
        @buffer=unpack('v',$input_buffer);
        ($main{'total_shells'}) = @buffer;

        foreach (1..$main{'total_shells'})  {
                my %this_main=();
                read(MAIN,$input_buffer,111);
                @buffer=unpack('Z41Z9Z41VZ16',$input_buffer);
                ($this_main{'name'},
                        $this_main{'code'},
                        $this_main{'ar'},
                        $this_main{'misc'}) = @buffer;
		
                push @{$main{'command_shell'}},\%this_main;
	}

	close MAIN;
}

sub write_hash_txt  {
        my ($file,$prefix,%hash) = @_;
        foreach $key (sort keys %hash)  {
		my $reftype = ref($hash{$key});
		if ($reftype)  {
			if ($reftype eq 'ARRAY')  {
                                foreach (0..$#{$hash{$key}})  {
                                        if (ref(${$hash{$key}}[$_]))  {
                                                &write_hash_txt($file,"$prefix$key\[$_\]\.",%{${$hash{$key}}[$_]});
					}
					else  {
                                                print $file "$prefix$key\[$_\] = ",${$hash{$key}}[$_],"\n";
					}
				}
			}
		}
		else  {
                        print $file "$prefix$key",' = ',$hash{$key},"\n";
		}
	}
}

sub read_msgs  {

        my $unused = '';

        open MSGS,"$SBBS_CTRL_PATH/msgs.cnf";
        binmode(MSGS);

        read(MSGS,$input_buffer,1036);
        @buffer = unpack('VVvZ512Z512v',$input_buffer);
        ($msgs{'max_qwkmsgs'},$msgs{'mail_maxcrcs'},$msgs{'mail_maxage'},
                $unused,$unused,
                $msgs{'total_grps'}) = @buffer;

        foreach (1..$msgs{'total_grps'})  {
                my %this_msgs=();
                read(MSGS,$input_buffer,194);
                @buffer=unpack('Z41Z16Z41Z96',$input_buffer);
                ($this_msgs{'lname'},$this_msgs{'sname'},
                        $this_msgs{'ar'}) = @buffer;
                push @{$msgs{'grp'}},\%this_msgs;
	}

        read(MSGS,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($msgs{'total_subs'}) = @buffer;

        foreach (1..$msgs{'total_subs'})  {
                my %this_msgs=();
                read(MSGS,$input_buffer,697);
                @buffer=unpack('vZ41Z26Z11Z9Z64Z41Z41Z41Z41VZ81Z51Z64Z64a8VVvvZ41vZ53',$input_buffer);
                ($this_msgs{'grp'},$this_msgs{'lname'},
                        $this_msgs{'sname'},$this_msgs{'qwkname'},
                        $this_msgs{'code'},$this_msgs{'data_dir'},
                        $this_msgs{'ar'},$this_msgs{'read_ar'},
                        $this_msgs{'post_ar'},$this_msgs{'op_ar'},
                        $this_msgs{'misc'},$this_msgs{'tagline'},
                        $this_msgs{'originline'},$this_msgs{'echomail_sem'},
                        $this_msgs{'echopath'},$this_msgs{'faddr'},
                        $this_msgs{'maxmsgs'},$this_msgs{'maxcrcs'},
                        $this_msgs{'maxage'},$this_msgs{'ptridx'},
                        $this_msgs{'mod_ar'},
                        $this_msgs{'qwkconf'}) = @buffer;
                $this_msgs{'faddr'} = &expand_faddr($this_msgs{'faddr'});
                push @{$msgs{'sub'}},\%this_msgs;
	}

        read(MSGS,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($msgs{'total_faddrs'}) = @buffer;

        foreach (1..$msgs{'total_faddrs'})  {
                my %this_msgs=();
                read(MSGS,$input_buffer,8);
                push @{$msgs{'faddr'}},&expand_faddr($input_buffer);
        }

        read(MSGS,$input_buffer,441);
        @buffer = unpack('Z51Z64Z64Z64Z64Z64vVa8Z56',$input_buffer);
        ($msgs{'origline'},$msgs{'netmail_sem'},$msgs{'echomail_sem'},
                $msgs{'netmail_dir'},$msgs{'echomail_dir'},$msgs{'fidofile_dir'},
                $msgs{'netmail_misc'},$msgs{'netmail_cost'},
                $msgs{'dflt_faddr'}) = @buffer;
        $msgs{'dflt_faddr'} = &expand_faddr($msgs{'dflt_faddr'});

        read(MSGS,$input_buffer,128);
        @buffer = unpack('Z128',$input_buffer);
        ($msgs{'qnet_tagline'}) = @buffer;

        read(MSGS,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($msgs{'total_qhubs'}) = @buffer;

        foreach (1..$msgs{'total_qhubs'})  {
                my %this_msgs=();
                read(MSGS,$input_buffer,207);
                @buffer=unpack('Z9vvCvZ64Z64Z64v',$input_buffer);
                ($this_msgs{'id'},$this_msgs{'time'},
                                $this_msgs{'freq'},$this_msgs{'days'},
                                $this_msgs{'node'},$this_msgs{'call'},
                                $this_msgs{'pack'},$this_msgs{'unpack'},
                                $this_msgs{'subs'}) = @buffer;
                foreach (1..$this_msgs{'subs'})  {
                        my %this_msgs2=();
                        read(MSGS,$input_buffer,5);
                        @buffer=unpack('vvC',$input_buffer);
                        ($this_msgs2{'conf'},
                                $this_msgs2{'sub'},
                                $this_msgs2{'mode'}) = @buffer;
                        push @{$this_msgs{'qsub'}},\%this_msgs;
                }
                read(MSGS,$input_buffer,64);
                push @{$msgs{'qhub'}},\%this_msgs;
	}
        read(MSGS,$input_buffer,75);

        read(MSGS,$input_buffer,4);
        @buffer=unpack('V',$input_buffer);
        ($msgs{'sys_psnum'}) = @buffer;

        read(MSGS,$input_buffer,2);
        @buffer=unpack('v',$input_buffer);
        ($msgs{'total_phubs'}) = @buffer;

        foreach (1..$msgs{'total_phubs'})  {
                my %this_msgs=();
                read(MSGS,$input_buffer,123);
                @buffer=unpack('Z11vvCvZ41Z64',$input_buffer);
                ($this_msgs{'name'},$this_msgs{'time'},
                        $this_msgs{'freq'},$this_msgs{'days'},
                        $this_msgs{'node'},
                        $this_msgs{'call'}) = @buffer;
                push @{$msgs{'phub'}},\%this_msgs;
	}

        read(MSGS,$input_buffer,141);
        @buffer=unpack('Z64Z13Z64',$input_buffer);
        ($unused,$msgs{'sys_psname'},$unused) = $buffer;

        read(MSGS,$input_buffer,128);
        @buffer=unpack('Z128',$input_buffer);
        ($msgs{'sys_inetaddr'}) = @buffer;

        close MSGS;
}

sub expand_faddr  {
        my ($faddr) = @_;
        @faddr = unpack('vvvv',$faddr);
        return ($faddr[0].':'.$faddr[1].'/'.$faddr[2].'.'.$faddr[3]);
}

sub read_file  {
        open FILE,"$SBBS_CTRL_PATH/file.cnf";
        binmode(FILE);

        read(FILE,$input_buffer,152);
        @buffer = unpack('vvvvVvvVZ64vvZ64',$input_buffer);
        ($file{'min_dspace'},$file{'max_batup'},$file{'max_batdn'},
                $file{'max_userxfer'},$unused,$file{'default_cdt_up_pct'},
                $file{'default_cdt_dn_pct'},$unused,$unused,
                $file{'leech_pct'},$file{'leech_sec'}) = @buffer;

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_fextrs'}) = @buffer;
        foreach (1..$file{'total_fextrs'})  {
                my %this_file=();
                read(FILE,$input_buffer,125);
                @buffer=unpack('Z4Z64Z41Z16',$input_buffer);
                ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'fextr'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_fcomps'}) = @buffer;
        foreach (1..$file{'total_fcomps'})  {
                my %this_file=();
                read(FILE,$input_buffer,125);
                @buffer=unpack('Z4Z64Z41Z16',$input_buffer);
                ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'fcomp'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_fviews'}) = @buffer;
        foreach (1..$file{'total_fviews'})  {
                my %this_file=();
                read(FILE,$input_buffer,125);
                @buffer=unpack('Z4Z64Z41Z16',$input_buffer);
                ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'fview'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_ftests'}) = @buffer;
        foreach (1..$file{'total_ftests'})  {
                my %this_file=();
                read(FILE,$input_buffer,166);
                @buffer=unpack('Z4Z64Z41Z41Z16',$input_buffer);
                ($this_file{'ext'},$this_file{'cmd'},$this_file{'workstr'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'ftest'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_dlevents'}) = @buffer;
        foreach (1..$file{'total_dlevents'})  {
                my %this_file=();
                read(FILE,$input_buffer,166);
                @buffer=unpack('Z4Z64Z41Z41Z16',$input_buffer);
                ($this_file{'ext'},$this_file{'cmd'},
                        $this_file{'workstr'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'dlevent'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_prots'}) = @buffer;
        foreach (1..$file{'total_prots'})  {
                my %this_file=();
                read(FILE,$input_buffer,472);
                @buffer=unpack('AZ26Z64Z64Z64Z64Z64Z64VZ41Z16',$input_buffer);
                ($this_file{'mnemonic'},$this_file{'name'},
                        $this_file{'ulcmd'},$this_file{'dlcmd'},
                        $this_file{'batulcmd'},$this_file{'batdlcmd'},
                        $this_file{'unused'},$this_file{'bicmd'},
                        $this_file{'misc'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'prot'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'altpaths'}) = @buffer;
        foreach (1..$file{'altpaths'})  {
                my %this_file=();
                read(FILE,$input_buffer,80);
                @buffer=unpack('Z64Z16',$input_buffer);
                push @{$file{'altpath'}},@buffer;
        }
        
        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_libs'}) = @buffer;
        foreach (1..$file{'total_libs'})  {
                my %this_file=();
                read(FILE,$input_buffer,194);
                @buffer=unpack('Z41Z16Z41Z96',$input_buffer);
                ($this_file{'lname'},$this_file{'sname'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'lib'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_dirs'}) = @buffer;
        foreach (1..$file{'total_dirs'})  {
                my %this_file=();
                read(FILE,$input_buffer,579);
                @buffer=unpack('vZ41Z26Z9Z64Z41Z41Z41Z41Z64Z64vZ41VCCZ41vvvZ49',$input_buffer);
                ($this_file{'lib'},$this_file{'lname'},
                        $this_file{'sname'},$this_file{'code'},
                        $this_file{'data_dir'},$this_file{'ar'},
                        $this_file{'ul_ar'},$this_file{'dl_ar'},
                        $this_file{'op_ar'},$this_file{'path'},
                        $this_file{'upload_sem'},$this_file{'maxfiles'},
                        $this_file{'exts'},$this_file{'misc'},
                        $this_file{'seqdev'},$this_file{'sort'},
                        $this_file{'ex_ar'},$this_file{'maxage'},
                        $this_file{'up_pct'},
                        $this_file{'dn_pct'}) = @buffer;
                push @{$file{'dir'}},\%this_file;
        }

        read(FILE,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($file{'total_txtsecs'}) = @buffer;
        foreach (1..$file{'total_txtsecs'})  {
                my %this_file=();
                read(FILE,$input_buffer,107);
                @buffer=unpack('Z41Z9Z41Z16',$input_buffer);
                ($this_file{'name'},$this_file{'code'},
                        $this_file{'ar'}) = @buffer;
                push @{$file{'txtsec'}},\%this_file;
        }

        close FILE;
}

sub read_xtrn  {
        open XTRN,"$SBBS_CTRL_PATH/xtrn.cnf";
        binmode(XTRN);

        read(XTRN,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($xtrn{'total_swaps'}) = @buffer;
        foreach (1..$xtrn{'total_swaps'})  {
                read(XTRN,$input_buffer,64);
                @buffer=unpack('Z64',$input_buffer);
                push @{$xtrn{'swap->cmd'}},@buffer;
        }

        read(XTRN,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($xtrn{'total_xedits'}) = @buffer;
        foreach (1..$xtrn{'total_xedits'})  {
                my %this_xtrn=();
                read(XTRN,$input_buffer,239);
                @buffer=unpack('Z41Z9Z64Z64VZ41Z16',$input_buffer);
                ($this_xtrn{'name'},$this_xtrn{'code'},
                        $this_xtrn{'lcmd'},$this_xtrn{'rcmd'},
                        $this_xtrn{'misc'},
                        $this_xtrn{'ar'}) = @buffer;
                push @{$xtrn{'xedit'}},\%this_xtrn;
        }

        read(XTRN,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($xtrn{'total_xtrnsecs'}) = @buffer;
        foreach (1..$xtrn{'total_xtrnsecs'})  {
                my %this_xtrn=();
                read(XTRN,$input_buffer,107);
                @buffer=unpack('Z41Z9Z41Z16',$input_buffer);
                ($this_xtrn{'name'},$this_xtrn{'code'},
                        $this_xtrn{'ar'}) = @buffer;
                push @{$xtrn{'xtrnsec'}},\%this_xtrn;
        }

        read(XTRN,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($xtrn{'total_xtrns'}) = @buffer;
        foreach (1..$xtrn{'total_xtrns'})  {
                my %this_xtrn=();
                read(XTRN,$input_buffer,352);
                @buffer=unpack('vZ41Z9Z41Z41CVCVZ64Z64Z64Z16',$input_buffer);
                ($this_xtrn{'sec'},$this_xtrn{'name'},
                        $this_xtrn{'code'},$this_xtrn{'ar'},
                        $this_xtrn{'run_ar'},$this_xtrn{'type'},
                        $this_xtrn{'misc'},$this_xtrn{'event'},
                        $this_xtrn{'cost'},$this_xtrn{'cmd'},
                        $this_xtrn{'clean'},
                        $this_xtrn{'path'}) = @buffer;
                push @{$xtrn{'xtrn'}},\%this_xtrn;
        }

        read(XTRN,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($xtrn{'total_events'}) = @buffer;
        foreach (1..$xtrn{'total_events'})  {
                my %this_xtrn=();
                read(XTRN,$input_buffer,162);
                @buffer=unpack('Z9Z64CvvVZ64Z16',$input_buffer);
                ($this_xtrn{'code'},$this_xtrn{'cmd'},
                        $this_xtrn{'days'},$this_xtrn{'time'},
                        $this_xtrn{'node'},$this_xtrn{'misc'},
                        $this_xtrn{'dir'}) = @buffer;
                push @{$xtrn{'event'}},\%this_xtrn;
        }

	read(XTRN,$input_buffer,2);
	@buffer = unpack('v',$input_buffer);
	($xtrn{'total_natvpgms'}) = @buffer;
	foreach (1..$xtrn{'total_natvpgms'})  {
                my %this_xtrn=();
                read(XTRN,$input_buffer,13);
                @buffer=unpack('Z13',$input_buffer);
                push @{$xtrn{'natvpgms->name'}},@buffer;
	}
	foreach (1..$xtrn{'total_natvpgms'})  {
                my %this_xtrn=();
                read(XTRN,$input_buffer,4);
                @buffer=unpack('V',$input_buffer);
                push @{$xtrn{'natvpgms->misc'}},@buffer;
	}
        close XTRN
}

sub read_chat  {
        open CHAT,"$SBBS_CTRL_PATH/chat.cnf";
        binmode(CHAT);

        read(CHAT,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($chat{'total_gurus'}) = @buffer;
        foreach (1..$chat{'total_gurus'})  {
                my %this_chat=();
                read(CHAT,$input_buffer,92);
                @buffer=unpack('Z26Z9Z41Z16',$input_buffer);
                ($this_chat{'name'},$this_chat{'code'},
                        $this_chat{'ar'}) = @buffer;
                push @{$chat{'guru'}},\%this_chat;
        }

        read(CHAT,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($chat{'total_actsets'}) = @buffer;
        foreach (1..$chat{'total_actsets'})  {
                read(CHAT,$input_buffer,26);
                @buffer=unpack('Z26',$input_buffer);
                push @{$chat{'actset->name'}},@buffer;
        }

        read(CHAT,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($chat{'total_chatacts'}) = @buffer;
        foreach (1..$chat{'total_chatacts'})  {
                my %this_chat=();
                read(CHAT,$input_buffer,94);
                @buffer=unpack('vZ10Z66Z16',$input_buffer);
                ($this_chat{'actset'},$this_chat{'cmd'},
                        $this_chat{'out'}) = @buffer;
                push @{$chat{'chatact'}},\%this_chat;
        }

        read(CHAT,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($chat{'total_chans'}) = @buffer;
        foreach (1..$chat{'total_chans'})  {
                my %this_chat=();
                read(CHAT,$input_buffer,104);
                @buffer=unpack('vZ26Z9Z41VvVZ16',$input_buffer);
                ($this_chat{'actset'},$this_chat{'name'},
                        $this_chat{'code'},$this_chat{'ar'},
                        $this_chat{'cost'},$this_chat{'guru'},
                        $this_chat{'misc'}) = @buffer;
                push @{$chat{'chan'}},\%this_chat;
        }

        read(CHAT,$input_buffer,2);
        @buffer = unpack('v',$input_buffer);
        ($chat{'total_pages'}) = @buffer;
        foreach (1..$chat{'total_pages'})  {
                my %this_chat=();
                read(CHAT,$input_buffer,125);
                @buffer=unpack('Z64Z41VZ16',$input_buffer);
                ($this_chat{'cmd'},$this_chat{'ar'},
                        $this_chat{'misc'}) = @buffer;
                push @{$chat{'page'}},\%this_chat;
        }

        close CHAT;
}

sub read_node  {
        my ($NODE_PATH) = @_;

        open NODE,"$NODE_PATH/node.cnf";
        binmode(NODE);

        read(NODE,$input_buffer,3055);
        @buffer = unpack('vZ41Z13Z64VvCZ64vvZ41CZ64Z64Z64CCZ64Z64Z64Z64Z64Z'.
                '64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64Z64'.
                'Z64Z512Z512',$input_buffer);
        ($node{'node_num'},$node{'node_name'},$node{'node_phone'},
                $node{'node_logon'},$node{'node_misc'},$node{'node_ivt'},
                $node{'node_swap'},$node{'node_swapdir'},$node{'node_valuser'},
                $node{'node_minbps'},$node{'node_ar'},$node{'node_dollars_per_call'},
                $node{'node_editor'},$node{'node_viewer'},$node{'node_daily'},
                $node{'node_scrnlen'},$node{'node_scrnblank'},$node{'ctrl_dir'},
                $node{'text_dir'},$node{'temp_dir'},$node{'wfc_cmd1'},
                $node{'wfc_cmd2'},$node{'wfc_cmd3'},$node{'wfc_cmd4'},
                $node{'wfc_cmd5'},$node{'wfc_cmd6'},$node{'wfc_cmd7'},
                $node{'wfc_cmd8'},$node{'wfc_cmd9'},$node{'wfc_cmd10'},
                $node{'wfc_scmd1'},$node{'wfc_scmd2'},$node{'wfc_scmd3'},
                $node{'wfc_scmd4'},$node{'wfc_scmd5'},$node{'wfc_scmd6'},
                $node{'wfc_scmd7'},$node{'wfc_scmd8'},$node{'wfc_scmd9'},
                $node{'wfc_scmd10'},$node{'wfc_scmd11'},
                $node{'wfc_scmd12'}) = @buffer;

        read(NODE,$input_buffer,9);
        @buffer=unpack('CvvV',$input_buffer);
        ($node{'com_port'},$node{'com_irq'},$node{'com_base'},
                $node{'com_rate'}) = @buffer;

        read(NODE,$input_buffer,395);
        @buffer=unpack('VZ64Z64Z64Z64Z64Z64vvCv',$input_buffer);
        ($node{'mdm_misc'},$node{'mdm_init'},$node{'mdm_spec'},
                $node{'mdm_term'},$node{'mdm_dial'},$node{'mdm_offh'},
                $node{'mdm_answ'},$node{'mdm_reinit'},$node{'mdm_ansdelay'},
                $node{'mdm_rings'},$node{'mdm_results'}) = @buffer;

        foreach (1..$node{'mdm_results'})  {
                my %this_node=();
                read(NODE,$input_buffer,17);
                @buffer=unpack('vvvZ9',$input_buffer);
                ($this_node{'code'},$this_node{'rate'},
                        $this_node{'cps'},
                        $this_node{'str'}) = @buffer;
                push @{$node{'mdm_result'}},\%this_node;
        }

        close NODE;
}

__END__
:endofperl
